unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs,httpsend,synacode, Vcl.StdCtrls, ssl_openssl,ssl_openssl_lib,
  Vcl.OleCtrls, SHDocVw, Vcl.ExtCtrls;

const
  //     web  acp_agent
  //     ,   
  //  ://ip   :
  // ""   ( ):
  //https://IP__:6547
  //http://IP__:3052
  servers:array [0..4] of string=('https://IP__:6547',
                                  'http://IP__:3052',
                                  'http://localhost:3052',
                                  'https://localhost:6547');
  user_agent='Mozilla/5.0 (Windows NT 6.1; rv:14.0) Gecko/20100101 Firefox/14.0.1';
  content_type='application/x-www-form-urlencoded';

type
  TMainForm = class(TForm)
    logMemo: TMemo;
    WorkTimer: TTimer;
    MainTimer: TTimer;
    procedure mainlog(t:string);
    procedure FormCreate(Sender: TObject);
    procedure WorkTimerTimer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MainTimerTimer(Sender: TObject);
    procedure init_objects;
    procedure free_objects;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;
  stream: TStringStream;
  httpsend: THTTPSend;
  loc:string;
  c,s,state:integer;

implementation

{$R *.dfm}

procedure TMainForm.mainlog(t:string);
var
i:integer;
ScrollMessage:TWMVScroll;
begin
while pos(#13,t)<>0 do
    delete(t,pos(#13,t),1);
while pos(#10,t)<>0 do
    delete(t,pos(#10,t),1);
try
  logmemo.Lines.BeginUpdate;
  if length(t)>0 then
     if length(t)>2 then
        logmemo.lines.Append(datetimetostr(now)+' '+t)
     else
        logmemo.lines.Append('');
  while logmemo.lines.Count>1024 do
        logmemo.lines.Delete(0);
  ScrollMessage.Msg:=WM_VScroll;
  for i := logmemo.Lines.Count DownTo 0 do
        begin
        ScrollMessage.ScrollCode:=sb_LineDown;
        ScrollMessage.Pos:=0;
        logmemo.Dispatch(ScrollMessage);
        end;
  logmemo.Lines.EndUpdate;
  logmemo.update;
  //logmemo.lines.SaveToFile(ChangeFileExt(ParamStr(0), '.log'));
except
end;
end;

function GetLocation(const headers:TStringList):string;
var i:integer;
begin
result:='';
try
  for I := 0 to headers.Count - 1 do
    if pos('Location: ',headers[i])>0 then
        begin
          Result:=copy(headers[i],10,length(headers[i])-9);
          break;
        end;
finally
  result:=trim(result);
end;
end;

procedure TMainForm.init_objects;
begin
free_objects;
try
  stream:=TStringStream.Create('');
  httpsend:=THTTPSend.Create;
  HTTPSend.KeepAlive:=true;
  HTTPSend.Protocol:='1.1';
  //httpsend.KeepAliveTimeout:=300;
  httpsend.UserAgent:=User_agent;
  httpsend.MimeType:=Content_type;
  httpsend.Sock.CreateWithSSL(TSSLOpenSSL);
  httpsend.Sock.SSLDoConnect;
except
  mainlog('  ');
end;
end;

procedure TMainForm.free_objects;
begin
try
  stream.Free;
  httpsend.free;
except
  mainlog('  ');
end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
logmemo.Clear;
try
  logmemo.lines.LoadfromFile(ChangeFileExt(ParamStr(0), '.log'));
except
end;
mainlog(' ');
mainlog(' ');
s:=-1;
c:=100;
maintimer.Enabled:=true;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
mainlog(' ');
free_objects;
end;

procedure TMainForm.MainTimerTimer(Sender: TObject);
begin
maintimer.Enabled:=false;
maintimer.Interval:=1000;
worktimer.Interval:=300;
try
  if state=4 then
    begin
    mainlog(servers[s]+' !');
    c:=6;
    end;
  if c>=6 then
    begin
    init_objects;
    state:=0;
    c:=0;
    inc(s);
    if pos('https:',servers[s])<>0 then
      state:=1;
    end;
  if s<=high(servers) then
    begin
    if c=0 then
      worktimer.Enabled:=true;
    end
  else
    close;
  inc(c);
finally
  maintimer.Enabled:=true;
end;
end;

procedure TMainForm.WorkTimerTimer(Sender: TObject);
begin
try
  worktimer.Enabled:=false;
  try
   case state of
    0:begin //    
        loc:=servers[s];
        mainlog('post->'+loc);
        httpsend.Headers.Clear;
        httpsend.UserAgent:=User_agent;
        httpsend.MimeType:=Content_type;
        httpsend.Document.Clear;
        if httpsend.HTTPMethod('post',loc) then
          state:=1;
      end;
    1:begin // https   
        loc:=servers[s];
        if httpsend.ResultCode=302 then
          loc:=GetLocation(httpsend.Headers);
        mainlog('post->'+loc+'/login');
        httpsend.Headers.Clear;
        httpsend.UserAgent:=User_agent;
        httpsend.MimeType:=Content_type;
        httpsend.Document.Clear;
        if httpsend.HTTPMethod('post',loc+'/login') then
           state:=2;
      end;
    2:begin//  
        mainlog('get->'+loc+'/j_security_check');
        httpsend.Headers.Clear;
        httpsend.UserAgent:=User_agent;
        httpsend.MimeType:=Content_type;
        httpsend.Document.Clear;
	//         
        if httpsend.HTTPMethod('get',loc+'/j_security_check?j_username=Admin&j_password=xxxxxx') then
          begin
          if pos('/main',ansilowercase(GetLocation(httpsend.Headers)))<>0 then
            state:=3;
          end;
      end;
    3:begin //  !    shutdown  10 
        mainlog('post->'+loc+'/psshutdownnow');
        httpsend.Headers.Clear;
        httpsend.UserAgent:=User_agent;
        httpsend.MimeType:=Content_type;
        httpsend.Document.Clear;
        stream.Clear;
        stream.Position:=0;
        //,       UPS
        //   -   10 
        //   14 
        stream.WriteString('new.minute.ShutdownDelay=10'+
                           '&new.second.ShutdownDelay=0'+
                           '&old.minute.ShutdownDelay=5'+
                           '&old.second.ShutdownDelay=0'+
                           '&new.UPSShutdownType=TurnOnType.delayed'+
                           '&old.UPSShutdownType=TurnOnType.delayed'+
                           '&new.WakeupDelay.days=0'+
                           '&new.WakeupDelay.hours=14'+
                           '&new.WakeupDelay.minutes=0'+
                           '&old.WakeupDelay.days=-1'+
                           '&old.WakeupDelay.hours=-1'+
                           '&old.WakeupDelay.minutes=-1');
        stream.Position:=0;
        httpsend.Document.CopyFrom(stream,stream.Size);
        if httpsend.HTTPMethod('post',loc+'/psshutdownnow') then
          state:=4;
      end;
   end;
  except
   mainlog('   ');
  end;
finally
  worktimer.Enabled:=true;
end;
end;

end.
